#!/bin/sh
#
SUDO=sudo
PCITOOL=/usr/sbin/pcitool

CPU_START=4
CPU_OFF=128
PSET_OFF=64

set -A nexus_arr 3c0
set -A inst_arr 1
z=0
for X in 0
do
        # Get the MSI list for this device for Driver txns
	I=${inst_arr[$X]}
        echo Configuring intrs for mpt_sas#${I}
        NEXUS=/pci@${nexus_arr[$z]}
        ino_cnt=`$SUDO $PCITOOL $NEXUS -i | grep -c mpt_sas#${I}`
        set -A ino_arr `$SUDO $PCITOOL $NEXUS -i | grep mpt_sas#${I} | sort +0.10 | awk '{print $3}'`

        # Build the CPU array                   # cpu offset + (chip number X 128)
        CS0=8
        CS1=9
        CS2=10
        CS3=11
        CS4=8
        CS5=9
        CS6=10
        CS7=11
        CS8=136
        CS9=137
        CS10=138
        CS11=139
        CS12=136
        CS13=137
        CS14=138
        CS15=139

        echo "Targeted cpus: $CS0 $CS1 $CS2 $CS3 $CS4 $CS5 $CS6 $CS7 $CS8 $CS9 $CS10 $CS11 $CS12 $CS13 $CS14 $CS15"
        set -A cpu_arr `printf "%x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x" $CS0 $CS1 $CS2 $CS3 $CS4 $CS5 $CS6 $CS7 $CS8 $CS9 $CS10 $CS11 $CS12 $CS13 $CS14 $CS15`

        # Program the CPU binding for this MSI
        i=0
        while [ $i -lt $ino_cnt ] ; do
                $SUDO $PCITOOL $NEXUS -m ${ino_arr[$i]} -w ${cpu_arr[$i]}
                i=`expr $i + 1`
        done
done

