################################################################################
Configure the QLC driver to run in target mode to prepare the Sun Server X4-2L
to be a COMSTAR server.
################################################################################
  Enable stmf services
  % svcadm enable stmf

  Verify QLC device contains pciex1077,2532
  % echo ::devbindings -q qlc | mdb -k
  ffffff02d280f580 pciex1077,2532, instance #0 (driver name: qlc)
  ffffff02d280f2d0 pciex1077,2532, instance #1 (driver name: qlc)

  Notify the system to replace the qlc driver with the the qlt (Qlogic
  Target driver) for this device.
  % cp /etc/driver_aliases /etc/driver_aliases.orig
  % update_drv -d -i '"pciex1077,2532"' qlc
  % nawk '!($1 == "qlc" && $2 == "\"pciex1077,2532\"")' /etc/driver_aliases > /etc/driver_aliases.new
  % cp /etc/driver_aliases.new /etc/driver_aliases
  % update_drv -a -i '"pciex1077,2532"' qlt
  devfsadm: driver failed to attach: qlt
  Warning: Driver (qlt) successfully added to system but failed to attach

  Reboot the system to complete qlt driver install
  % reboot

  After reboot, check that qlc devices are now in target mode
  where the qlt driver is loaded:

  %  echo "::devbindings -q qlt" | mdb -k
  ffffff024eb84580 pciex1077,2532, instance #0 (driver name: qlt)
  ffffff024eb842d0 pciex1077,2532, instance #1 (driver name: qlt)

 % fcinfo hba-port | egrep 'HBA|Mode|Driver Name'
  HBA Port WWN: 21000024ff303b22
        Port Mode: Target
        Model: QLE2562
        Driver Name: COMSTAR QLT
  HBA Port WWN: 21000024ff303b23
        Port Mode: Target
        Model: QLE2562
        Driver Name: COMSTAR QLT

Note: the WWN numbers listed by fcinfo will be different
than those listed above.

