#!/bin/sh
#

# Configure target group
% svcadm disable stmf
% stmfadm create-tg tg0
% stmfadm list-tg
        Target Group: tg0
% stmfadm list-target
        Target: wwn.21000024FF47ABEF
        Target: wwn.21000024FF47ABEE
% stmfadm add-tg-member -g tg0 wwn.21000024FF47ABEF
% stmfadm add-tg-member -g tg0 wwn.21000024FF47ABEE
% stmfadm list-tg -v
        Target Group: tg0
        Member: wwn.21000024FF47ABEF
        Member: wwn.21000024FF47ABEE
% svcadm enable stmf

# Create the LUNS
% for mdnum in 11 12
do
        GUID=`printf "600144F0A3770E00000000000D11D%03d\n" ${mdnum}`
        stmfadm create-lu -p guid=${GUID}  /dev/md/rdsk/d${mdnum}
        stmfadm add-view -t tg0 $GUID
done

